package pesistas;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DialogoIntentos extends JDialog{
	
	private JTextField[] jtIntentos;
	private float[] intentos;
	public JButton btAceptar;
	
	public DialogoIntentos(Frame parent, float[] intentos) {
		super(parent, true);
		setTitle("Puntuaciones");
		jtIntentos = new JTextField[intentos.length];
		this.intentos = intentos;
		btAceptar = new JButton("Aceptar");
		btAceptar.addActionListener(new AccionAceptar());
		JPanel principal = new JPanel();
		principal.setLayout(new BoxLayout(principal, BoxLayout.Y_AXIS));
		
		JPanel enunciado = new JPanel();
		enunciado.add(new JLabel("Ingrese puntuaciones"));
		principal.add(enunciado);
		for (int i = 0; i < jtIntentos.length; i++) {
			jtIntentos[i] = new JTextField(3);
			jtIntentos[i].setText("0");
			principal.add(new PanelIntento(i, jtIntentos[i]));
		}
		JPanel boton = new JPanel();
		boton.add(btAceptar);
		principal.add(boton);
		
		setContentPane(principal);
		setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		pack();
		setResizable(false);
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private void cerrarDialogo() {
		dispose();
	}
	
	class PanelIntento extends JPanel {
		public PanelIntento(int num, JTextField campo) {
			add(new JLabel(String.format("Intento #%02d", num+1)));
			add(campo);
		}
	}
	
	class AccionAceptar implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			try {
				for (int i = 0; i < intentos.length; i++) {
					intentos[i] = Float.parseFloat(jtIntentos[i].getText());
				}
				cerrarDialogo();	
			}catch(NumberFormatException ex) {
				JOptionPane.showMessageDialog(null, "Algunos campos no contienen datos válidos",
						"Guardar Intentos", JOptionPane.WARNING_MESSAGE);
			}	
		}
		
	}

}
