package pesistas;

import java.util.Vector;

import javax.swing.JOptionPane;

public class Juegos_Deportivos {
	private Vector<Jugador_de_Campo> Jugadores_de_Campo;
	private Vector<Pesista> Pesistas;

	public Juegos_Deportivos() {
		Jugadores_de_Campo = new Vector<Jugador_de_Campo>();
		Pesistas= new Vector<Pesista>();
	}

	public void insertar_pesista(String nombre, String pais, float peso, float envion, float palanqueta, float arranque) {
		Pesistas.addElement(new Pesista(nombre,pais,peso,envion,palanqueta,arranque));
	}

	public void insertar_Jugador_de_Campo(String nombre, String pais, String deporte, float[] resultados) {
		Jugadores_de_Campo.addElement(new Jugador_de_Campo(nombre,pais,deporte,resultados));
	}

	public String Ganador_de_Campo(String deporte){

		//Pedimos un Vector con SOLO los jugadores correspondientes a este deporte
		Vector<Jugador_de_Campo> jugadores = getJugadoresDeporte(deporte);
		if (jugadores.isEmpty()) {
			JOptionPane.showMessageDialog(null, "No hay Jugadores para el Deporte: " + deporte,
					"Jugadores de Campo", JOptionPane.WARNING_MESSAGE);
			return null;
		}
		else {
			//Si hay Jugadores para este Deporte, buscamos al ganador
			float mayor = 0;
			String nombre = "";
			for (Jugador_de_Campo jugador: jugadores)
				if (jugador.getResultado_Final() > mayor) {
					mayor = jugador.getResultado_Final();
					nombre = jugador.getNombre();
				}
			return nombre;
		}
	}

	/*
	 * Metodo de apoyo.
	 * Devuelve un Vector con los jugadores que coinciden con el deporte indicado
	 */
	private Vector<Jugador_de_Campo> getJugadoresDeporte(String deporte) {
		Vector<Jugador_de_Campo> jugadores = new Vector<Jugador_de_Campo>();
		for (Jugador_de_Campo jugador: Jugadores_de_Campo)
			if (jugador.getDeporte().equals(deporte))
				jugadores.addElement(jugador);

		return jugadores;
	}


	public Float Mayor_Resultado_de_Jugadores(String jug){
		//Buscamos al Jugador que coincida con el nombre, si es que existe...
		for (Jugador_de_Campo jugador: Jugadores_de_Campo)
			if (jugador.getNombre().equals(jug))
				return jugador.getResultado_Final();
		
		//Si terminado el bucle no se ha retornado nada, es que no existe este jugador
		JOptionPane.showMessageDialog(null, "No hay ningun Jugador de Campo con nombre: " + jug,
				"Pesistas", JOptionPane.WARNING_MESSAGE);
		return null;
	}



	public String Mayor_que_Marca(float pes, float marca) {
		//Hacemos una seleccion de pesistas que coincidan con el peso indicado
		Vector<Pesista> seleccion = pesistasPorPeso(pes);
		if (seleccion.isEmpty()) {
			JOptionPane.showMessageDialog(null, "No hay Pesistas para el peso: " + pes,
					"Pesistas", JOptionPane.WARNING_MESSAGE);
			return null;
		}
		else {
			//Buscamos quienes superan la marca. Pueden ser varios, los juntaremos en un String
			String superanMarca = "";
			for (Pesista pesista: seleccion)
				if (pesista.getResultadofinal() > marca)
					superanMarca += pesista.getNombre() + "\n";
			//Comprobamos si hemos encontrado alguno
			if (superanMarca.isEmpty()) {
				JOptionPane.showMessageDialog(null, "Ningun Pesista supera la marca: " + marca,
						"Pesistas", JOptionPane.WARNING_MESSAGE);
				return null;
			}
			else
				return superanMarca;
				
		}
	}
	
	/*
	 * Metodo de apoyo.
	 * Retorna un Vector con una seleccion de Pesistas segun el peso
	 */
	private Vector<Pesista> pesistasPorPeso(float peso) {
		Vector<Pesista> seleccionPesistas = new Vector<Pesista>();
		for (Pesista pesista: Pesistas)
			if (pesista.getPeso() == peso)
				seleccionPesistas.addElement(pesista);
		
		return seleccionPesistas;
		
	}
}