package pesistas;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;

public class NuevaInterfaz extends JFrame{
	
	private Juegos_Deportivos jd;
	private PanelSuperior jpSuperior;
	//Componentes Pesista
	private JTextField jtNombrePesista;
	private JTextField jtPaisPesista;
	private JTextField jtPesoPesista;
	private JTextField jtEnvionPesista;
	private JTextField jtPalanquetaPesista;
	private JTextField jtArranquePesista;
	private JButton btGuardarPesista;
	//Componentes JugadorCampo
	private JTextField jtNombreJugador;
	private JTextField jtPaisJugador;
	private JTextField jtDeporteJugador;
	private JTextField jtIntentosDeporte;
	private JButton btGuardarJugador;
	//Componentes Consultas Jugador
	private JTextField jtNombreDeporte;
	private JButton btMostrarGanador;
	private JTextField jtNombreJugadorCampo;
	private JButton btMostrarResultado;
	//Componentes Consultas Pesista
	private JTextField jtMarca;
	private JTextField jtPeso;
	private JButton mostrarPesistas;
	
	public NuevaInterfaz() {
		super("Juegos Deportivos");
		iniciarComponentes();
		jd = new Juegos_Deportivos();
		jpSuperior = new PanelSuperior();
		
		JPanel principal = new JPanel();
		principal.setLayout(new BorderLayout());
		//Panel Superior
		principal.add(jpSuperior, BorderLayout.NORTH);
		//Panel central
		JPanel central = new JPanel();
		central.setLayout(new BoxLayout(central, BoxLayout.Y_AXIS));
		central.add(new PanelRegistrarPesista());
		central.add(new PanelConsultasPesista());
		central.add(new JSeparator(SwingConstants.HORIZONTAL));
		central.add(new PanelRegistrarJugador());
		central.add(new PanelConsultasJugador());
		
		principal.add(central, BorderLayout.CENTER);
		setContentPane(principal);
		pack();
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLocationRelativeTo(null);
		setVisible(true);
	}

	public static void main(String[] args) {
		for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
            if ("Nimbus".equals(info.getName())) {
                try {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
				} catch (Exception e) {
					e.printStackTrace();
				}
                break;
            }
        }
		java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	new NuevaInterfaz();
            }
		});

	}
	
	private void iniciarComponentes() {
		jtNombrePesista = new JTextField(6);
		jtPaisPesista = new JTextField(6);
		jtPesoPesista = new JTextField(3);
		jtEnvionPesista = new JTextField(3);
		jtPalanquetaPesista = new JTextField(3);
		jtArranquePesista = new JTextField(3);
		btGuardarPesista = new JButton("Guardar Pesista");
		btGuardarPesista.addActionListener(new AccionGuardarPesista());
		jtNombreJugador = new JTextField(6);
		jtPaisJugador = new JTextField(6);
		jtDeporteJugador = new JTextField(6);
		jtIntentosDeporte = new JTextField(2);
		btGuardarJugador = new JButton("Guardar Jugador");
		btGuardarJugador.addActionListener(new AccionRegistrarJugador());
		jtNombreDeporte = new JTextField(6);
		btMostrarGanador = new JButton("Mostrar Ganador");
		btMostrarGanador.addActionListener(new AccionMostrarGanador());
		jtNombreJugadorCampo = new JTextField(6);
		btMostrarResultado = new JButton("Mostrar Resultado");
		btMostrarResultado.addActionListener(new AccionMostrarResultado());
		jtMarca = new JTextField(3);
		jtPeso = new JTextField(3);
		mostrarPesistas = new JButton("Mostrar Pesistas");
		mostrarPesistas.addActionListener(new AccionConsultarPesista());
	}
	
	private void popUp(String mensaje, String titulo, int tipo) {
		JOptionPane.showMessageDialog(null, mensaje, titulo, tipo);
	}
	
	//Clases Paneles
	class PanelSuperior extends JPanel {
		private JLabel jlPesistas;
		private JLabel jlJugadores;
		
		public PanelSuperior() {
			jlPesistas = new JLabel("0");
			jlPesistas.setForeground(Color.BLUE);
			jlPesistas.setFont(new Font("Verdana", Font.BOLD, 12));
			jlJugadores = new JLabel("0");
			jlJugadores.setForeground(Color.BLUE);
			jlJugadores.setFont(new Font("Verdana", Font.BOLD, 12));
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
			JPanel izq = new JPanel();
			izq.add(new JLabel("Pesistas Registrados: "));
			izq.add(jlPesistas);
			JPanel der = new JPanel();
			der.add(new JLabel("Jugadores de Campo Registrados: "));
			der.add(jlJugadores);
			add(izq);
			add(der);
		}
		
		public void sumaPesista() {
			int valor = Integer.parseInt(jlPesistas.getText());
			jlPesistas.setText(Integer.toString(valor + 1));
		}
		
		public void sumaJugador() {
			int valor = Integer.parseInt(jlJugadores.getText());
			jlJugadores.setText(Integer.toString(valor + 1));
		}
	}
	
	class PanelRegistrarPesista extends JPanel {
		
		public PanelRegistrarPesista() {
			setBorder(javax.swing.BorderFactory.createCompoundBorder(new EmptyBorder(10, 20, 10, 20),
					new TitledBorder("Registrar Pesistas")));
			add(new PanelTextoConCampo("<html><p align = \"center\"><br>Nombre</p></html>", jtNombrePesista));
			add(new PanelTextoConCampo("<html><p align = \"center\"><br>Pais</p></html>", jtPaisPesista));
			add(new PanelTextoConCampo("<html><p align = \"center\"><br>Peso</p></html>", jtPesoPesista));
			add(new PanelTextoConCampo("<html><p align = \"center\">Resultado<br>Envion</p></html>", jtEnvionPesista));
			add(new PanelTextoConCampo("<html><p align = \"center\">Resultado<br>Palanquista</p></html>", jtPalanquetaPesista));
			add(new PanelTextoConCampo("<html><p align = \"center\">Resultado<br>Arranque</p></html>", jtArranquePesista));
			add(btGuardarPesista);
		}
	}
	
	class PanelConsultasPesista extends JPanel {
		
		public PanelConsultasPesista() {
			setBorder(javax.swing.BorderFactory.createCompoundBorder(new EmptyBorder(10, 20, 10, 20),
					new TitledBorder("Consultas Pesista")));
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			JPanel arriba = new JPanel();
			arriba.add(new JLabel("Indique la marca a superar y en que Peso se debe consultar"));
			JPanel abajo = new JPanel();
			abajo.setLayout(new FlowLayout(FlowLayout.CENTER, 60, 0));
			abajo.add(new PanelTextoConCampo("Marca", jtMarca));
			abajo.add(new PanelTextoConCampo("Peso", jtPeso));
			abajo.add(mostrarPesistas);
			
			add(arriba);
			add(abajo);
		}
	}
	
	class PanelRegistrarJugador extends JPanel {
		
		public PanelRegistrarJugador() {
			setBorder(javax.swing.BorderFactory.createCompoundBorder(new EmptyBorder(10, 20, 10, 20),
					new TitledBorder("Registrar Jugadores de Campo")));
			setLayout(new FlowLayout(FlowLayout.CENTER, 30, 0));
			add(new PanelTextoConCampo("Nombre", jtNombreJugador));
			add(new PanelTextoConCampo("Pais", jtPaisJugador));
			add(new PanelTextoConCampo("Deporte", jtDeporteJugador));
			add(new PanelTextoConCampo("Intentos", jtIntentosDeporte));
			add(btGuardarJugador);
		}
	}
	
	class PanelConsultasJugador extends JPanel {
		
		public PanelConsultasJugador() {
			setBorder(javax.swing.BorderFactory.createCompoundBorder(new EmptyBorder(10, 20, 10, 20),
					new TitledBorder("Consultas Jugadores de Campo")));
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
			//Parte izquierda
			JPanel izq = new JPanel();
			izq.setLayout(new BoxLayout(izq, BoxLayout.Y_AXIS));
			JPanel sobIzq = new JPanel();
			sobIzq.add(new JLabel("Indique Deporte para conocer Ganador"));
			JPanel subIzq = new JPanel();
			subIzq.add(jtNombreDeporte);
			subIzq.add(btMostrarGanador);
			izq.add(sobIzq);
			izq.add(subIzq);
			//Parte derecha
			JPanel der = new JPanel();
			der.setLayout(new BoxLayout(der, BoxLayout.Y_AXIS));
			JPanel sobDer = new JPanel();
			sobDer.add(new JLabel("Indique Nombre para conocer Resultado Final"));
			JPanel subDer = new JPanel();
			subDer.add(jtNombreJugadorCampo);
			subDer.add(btMostrarResultado);
			der.add(sobDer);
			der.add(subDer);
			//Añadimos paneles
			add(izq);
			add(der);
			
		}
	}
	
	class PanelTextoConCampo extends JPanel {
		
		public PanelTextoConCampo(String texto, JTextField campo) {
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			add(new JLabel(texto));
			add(campo);
		}
	}
	
	//Clases ActionListener
	class AccionGuardarPesista implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			// String nombre, String pais, float peso, float envion, float palanqueta, float arranque
			if (comprobarCamposObligatorios() && comprobarDatosNumericos()) {
				String nombre = jtNombrePesista.getText();
				String pais = jtPaisPesista.getText();
				float peso = Float.parseFloat(jtPesoPesista.getText());
				float envion = Float.parseFloat(jtEnvionPesista.getText());
				float palanqueta = Float.parseFloat(jtPalanquetaPesista.getText());
				float arranque = Float.parseFloat(jtArranquePesista.getText());
				jd.insertar_pesista(nombre, pais, peso, envion, palanqueta, arranque);
				popUp("Pesista Registrado", "Nuevo Pesista", JOptionPane.INFORMATION_MESSAGE);
				jpSuperior.sumaPesista();
				resetCampos();
			}
			
		}
		
		private void resetCampos() {
			jtNombrePesista.setText(null);
			jtNombrePesista.setBackground(Color.WHITE);
			jtPaisPesista.setText(null);
			jtPesoPesista.setText(null);
			jtPesoPesista.setBackground(Color.WHITE);
			jtEnvionPesista.setText(null);
			jtPalanquetaPesista.setText(null);
			jtArranquePesista.setText(null);
		}
		
		private boolean comprobarCamposObligatorios() {
			boolean valido = true;
			if (jtNombrePesista.getText().isEmpty()) {
				popUp("El campo Nombre es obligatorio", "Nuevo Pesista", JOptionPane.WARNING_MESSAGE);
				jtNombrePesista.setBackground(Color.RED);
				valido = false;
			}
			if (jtPesoPesista.getText().isEmpty()) {
				popUp("El campo Peso es obligatorio", "Nuevo Pesista", JOptionPane.WARNING_MESSAGE);
				jtPesoPesista.setBackground(Color.RED);
				valido = false;
			}
			return valido;
		}
		
		private boolean comprobarDatosNumericos() {
			/*
			 * Los campos vacios "no obligatorios" los pondremos a cero.
			 * Cuando ya no hayan campos vacios, comprobaremos si son "parseables" para asegurarnos
			 * de que tienen datos numéricos válidos para crear floats
			 */
			if (jtEnvionPesista.getText().isEmpty())
				jtEnvionPesista.setText("0");
			if (jtPalanquetaPesista.getText().isEmpty())
				jtPalanquetaPesista.setText("0");
			if (jtArranquePesista.getText().isEmpty())
				jtArranquePesista.setText("0");
			try {
				Float.parseFloat(jtPesoPesista.getText());
				Float.parseFloat(jtEnvionPesista.getText());
				Float.parseFloat(jtPalanquetaPesista.getText());
				Float.parseFloat(jtArranquePesista.getText());
				return true;
			}catch(NumberFormatException e) {
				popUp("Hay valores numéricos no válidos.\n"
						+ "Compruebe que solo contienen números y revise el tipo de separados decimal",
						"Nuevo Pesista", JOptionPane.WARNING_MESSAGE);
				return false;
			}
		}
	}
	
	class AccionConsultarPesista implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			if (compruebaCampos()) {
				float marca = Float.parseFloat(jtMarca.getText());
				float peso = Float.parseFloat(jtPeso.getText());
				String pesistasSuperan = jd.Mayor_que_Marca(peso, marca);
				if (pesistasSuperan != null)
					popUp("Pesistas que superan la marca: " + jtMarca.getText() + "\n" + pesistasSuperan,
							"Consultar Pesista", JOptionPane.INFORMATION_MESSAGE);
			}
			
		}
		
		private boolean compruebaCampos() {
			if (jtMarca.getText().isEmpty()) {
				jtMarca.setBackground(Color.RED);
				popUp("El campo Marca es obligatorio", "Consultar Pesista", JOptionPane.WARNING_MESSAGE);
				return false;
			}
			else {
				jtMarca.setBackground(Color.WHITE);
				try {
					Float.parseFloat(jtMarca.getText());
				}catch(NumberFormatException ex) {
					popUp("El campo Marca no tiene un valor numérico válido", "Consultar Pesista", JOptionPane.WARNING_MESSAGE);
					return false;
				}
			}
			if (jtPeso.getText().isEmpty()) {
				jtPeso.setBackground(Color.RED);
				popUp("El campo Peso es obligatorio", "Consultar Pesista", JOptionPane.WARNING_MESSAGE);
				return false;
			}
			else {
				jtPeso.setBackground(Color.WHITE);
				try {
					Float.parseFloat(jtPeso.getText());
				}catch(NumberFormatException ex) {
					popUp("El campo Peso no tiene un valor numérico válido", "Consultar Pesista", JOptionPane.WARNING_MESSAGE);
					return false;
				}
			}
			return true;
		}
	}
	
	class AccionRegistrarJugador implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			if (compruebaCamposObligatorios()) {
				String nombre = jtNombreJugador.getText();
				String pais = jtPaisJugador.getText();
				String deporte = jtDeporteJugador.getText();
				int intentos = Integer.parseInt(jtIntentosDeporte.getText());
				float[] resultados = new float[intentos];
				DialogoIntentos dial = new DialogoIntentos(null, resultados);
				jd.insertar_Jugador_de_Campo(nombre, pais, deporte, resultados);
				popUp("Jugador Registrado", "Nuevo Jugador", JOptionPane.INFORMATION_MESSAGE);
				jpSuperior.sumaJugador();
				resetCampos();
			}
			
		}
		
		private void resetCampos() {
			jtNombreJugador.setText(null);
			jtPaisJugador.setText(null);
			jtDeporteJugador.setText(null);
			jtIntentosDeporte.setText(null);
		}
		
		private boolean compruebaCamposObligatorios() {
			boolean valido = true;
			if (jtNombreJugador.getText().isEmpty()) {
				popUp("El campo Nombre es obligatorio", "Nuevo Jugador", JOptionPane.WARNING_MESSAGE);
				jtNombreJugador.setBackground(Color.RED);
				valido = false;
			}
			else
				jtNombreJugador.setBackground(Color.WHITE);
			
			if (jtDeporteJugador.getText().isEmpty()) {
				popUp("El campo Deporte es obligatorio", "Nuevo Jugador", JOptionPane.WARNING_MESSAGE);
				jtDeporteJugador.setBackground(Color.RED);
				valido = false;
			}
			else
				jtDeporteJugador.setBackground(Color.WHITE);
			
			if (jtIntentosDeporte.getText().isEmpty())
				jtIntentosDeporte.setText("1"); //Obligamos a que haya al menos 1 intento
			else {
				try {
					Integer.parseInt(jtIntentosDeporte.getText());
				} catch (NumberFormatException e) {
					popUp("El campo Intentos no tiene un valor numérico válido", "Nuevo Jugador", JOptionPane.WARNING_MESSAGE);
					valido = false;
				}
			}
			
			return valido;
		}
	}
	
	class AccionMostrarGanador implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			if (jtNombreDeporte.getText().isEmpty())
				popUp("Ha de indicar un Deporte", "Mostrar Ganador", JOptionPane.WARNING_MESSAGE);
			else {
				String ganador = jd.Ganador_de_Campo(jtNombreDeporte.getText());
				popUp("El Ganador es :\n" + ganador, "Mostrar Ganador", JOptionPane.INFORMATION_MESSAGE);
			}
			
		}
	}
	
	class AccionMostrarResultado implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			if (jtNombreJugadorCampo.getText().isEmpty())
				popUp("Ha de indiciar un nombre de Jugador", "Mostrar Resultado", JOptionPane.WARNING_MESSAGE);
			else {
				Float resultado = jd.Mayor_Resultado_de_Jugadores(jtNombreJugadorCampo.getText());
				if (resultado != null)
					popUp(String.format("Mejor resultado es: %.2f", resultado), "Mostrar Resultado",
							JOptionPane.INFORMATION_MESSAGE);
			}
			
		}
	}

}

